<template>
  <div>
    <SerieBannerDesktop
      :serie="serie"
      :is-subscription="isSubscription"
      :connected="connected"
      class="banner-desktop"
      @followSerie="followSerie"
      @facebookShare="facebookShare"
    />
    <SerieBannerMobile
      :serie="serie"
      :is-subscription="isSubscription"
      :connected="connected"
      class="banner-mobile"
      @followSerie="followSerie"
      @facebookShare="facebookShare"
    />
  </div>
</template>

<script>
import SerieBannerDesktop from '~/components/Serie/SerieBannerDesktop'
import SerieBannerMobile from '~/components/Serie/SerieBannerMobile'

export default {
  components: { SerieBannerDesktop, SerieBannerMobile },
  props: {
    serie: {
      type: Object,
      required: true
    },
    isSubscription: {
      type: Boolean,
      required: true
    },
    connected: {
      type: Boolean,
      required: false,
      default: false
    }
  },
  methods: {
    async followSerie() {
      this.$utils.gtmEvent({
        event: 'gtm.event',
        EventCategory: 'Clic_Bouton',
        EventAction: 'Suivre',
        EventLabel: `${this.serie.shelf.name}_${this.serie.name}`
      })

      if (!this.connected) {
        const url = this.$utils.getSignupUrlForLang(this.$i18n.locale)
        window.location.href = `${this.$config.izneoUrl}/${this.$i18n.locale}/${url}?redirect=${window.location.href}`
      } else {
        let data
        if (this.serie.isfollowing) {
          data = await this.$api.unFollowSerie(this.serie.id)
        } else {
          data = await this.$api.followSerie(this.serie.id)
        }
        if (data) {
          this.serie.isfollowing = !this.serie.isfollowing
        }
      }
    },
    facebookShare() {
      this.$utils.gtmEvent({
        event: 'gtm.event',
        EventCategory: 'Social',
        EventAction: 'facebook',
        EventLabel: `Partage_${this.serie.name}`
      })

      // eslint-disable-next-line no-undef
      FB.ui(
        {
          method: 'share',
          href: window.location.href
        },
        function () {}
      )
    }
  }
}
</script>

<style lang="scss">
.banner-mobile {
  display: none;
}

.banner-desktop {
  display: block;
}

@media (max-width: 768px) {
  .banner-mobile {
    display: block;
  }

  .banner-desktop {
    display: none;
  }
}
</style>
